#' # Introduction {#introduction}
#' 

#' 
#' **In the digital era, information is abundant a
#' 
#' In particular, datasets related to Economics an
#' 
#' Not surprisingly, fields with abundant access t
#' 
#' 
#' ## What is R
#' 
#' R is a programming language specially designed 
#' 
#' Today, R is almost synonymous with data analysi
#' 
#' On the business side, large and established com
#' 
#' 
#' ## Why Choose R
#' 
#' Learning a new programming language requires a 
#' 
#' First, **R is a mature and stable platform, con
#' 
#' **Learning R is easy**. My experience in teachi
#' 
#' **The engine of R and the interface of RStudio 
#' 
#' **CRAN Packages allow the user to do many diffe
#' 
#' **R is compatible with different operating syst
#' 
#' **R is free!** The main software and all its pa
#' 
#' 
#' ## What Can You Do With R and RStudio?
#' 
#' R is a fairly complete programming language and
#' 
#' - Substitute and improve data-intensive tasks f
#' 
#' - Develop routines for managing investment port
#' 
#' - Creating tools for calculating and reporting 
#' 
#' - Performing empirical data research using stat
#' 
#' - Create dynamic _websites_ with the `shiny` [@
#' 
#' - Automate the process of writing technical rep
#' 
#' Moreover, public access to packages developed b
#' 
## Be aware that R has a consistent release schedule. Every four months a new version of R is released, fixing _bugs_ and implementing new solutions. There are two main types of releases, _major_ and _minor_. For example, today, 2021-02-24, the latest version of R is 4.0.4. The first digit ("4") indicates the _major_ release while all others are of the _minor_ type. Generally, the _minor_ changes are very specific and, possibly, will have little impact on your work.

## 
## However, unlike _minor_ releases, **_major_ releases are fully reflected in the R package ecosystem**. Every time you install a new _major_ version of R, you will have to reinstall all packages. Particularly, the problem here is that it is not uncommon that a new major release comes with package incompatibility issues. My advice is: every time a new _major_ release of R comes out, **wait a few months** before installing it on your machine. Thus, the authors of the packages will have more time to update their codes, minimizing the possibility of compatibility problems.

#' 
#' ## Installing R {#installing}
#' 
#' Before going any further, let's install the req
#' 

#' 
#' The next screen gives you a choice of the mirro
#' 

#' 
#' The next step involves selecting your operating
#' 

#' 
#' After clicking the link _Download R for Windows
#' 
#' If the user is interested in creating and distr
#' 

#' 
#' After clicking the link _base_, the next screen
#' 

#' 
#' 
#' ## Installing RStudio
#' 
#' The base installation of R includes its own _GU
#' 
#' The installation of RStudio is simpler than tha
#' 
#' I emphasize that using RStudio is not essential
#' 
#' 
#' ## Resources in the Web
#' 
#' **The R community is vivid and engaging**. Ther
#' 
#' Learning and using R can be a social experience
#' 
#' 
#' ## Structure and Organization
#' 
#' This book presents a practical approach to usin
#' 
#' Learning to program in a new platform is like l
#' 
#' Throughout the book, every demonstration of cod
#' 
## -------------------------------------------------------------------------------------------------------------------
# create a list
L <- list('abc', 1:5, 'dec')

# print list
print(L)

#' 
#' For the previous chunk of code, lines `L <- lis
#' 
#' The code can also be spatially organized using 
#' 
## -------------------------------------------------------------------------------------------------------------------
# create a list
L <- list('abc', 
          1:5, 
          'dec')

# print list
print(L)

#' 
#' The code also follows a well-defined structure.
#' 
#' 
#' ## Exercises
#' 
## ---- echo=FALSE, results='asis'------------------------------------------------------------------------------------
f_in <- list.files('../02-EOCE-Rmd/Chapter01-Introduction/', 
                   full.names = TRUE)

compile_eoc_exercises(f_in, type_doc = my_engine)

#' 